//===========================================================================
// package
//===========================================================================
package jp.gr.java_conf.bugslife.action;

//===========================================================================
// import
//===========================================================================
import java.io.*;
import java.util.Locale;
import javax.servlet.*;
import javax.servlet.http.*;
import org.apache.commons.logging.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;
import org.apache.commons.beanutils.*;

import java.util.*;

import jp.gr.java_conf.bugslife.form.*;
import jp.gr.java_conf.bugslife.bug.*;
import jp.gr.java_conf.bugslife.user.*;
import jp.gr.java_conf.bugslife.system.*;
import jp.gr.java_conf.bugslife.util.Converter;
import jp.gr.java_conf.bugslife.util.MessageString;
/**
 *<PRE>
 * 
 * BugDownloadActionNX
 *
 *</PRE>
 * @version	0.0
 * @author	k 
 */
public final class BugDownloadAction extends BaseAction 
{
//===========================================================================
// attributes
//===========================================================================
    /** csvo͍ */
    
    String[][] CSV_ITEMS = {
    		{"bno.displayname", "bno" },
    		{"bid.displayname", "bid" },
    		{"title.displayname", "title" },
    		{"dispatchName.displayname", "dispatchName" },
    		{"location.displayname", "location" },
    		{"locationString.displayname", "locationString" },
    		{"functionName.displayname", "functionName" },
    		{"functionNameString.displayname", "functionNameString" },
    		{"screen.displayname", "screen" },
    		{"browser.displayname", "browser" },
    		{"browserString.displayname", "browserString" },
    		{"os.displayname", "os" },
    		{"osString.displayname", "osString" },
    		{"tid.displayname", "tid" },
    		{"appVersion.displayname", "appVersion" },
    		{"appVersionString.displayname", "appVersionString" },
    		{"dbVersion.displayname", "dbVersion" },
    		{"dbVersionString.displayname", "dbVersionString" },
    		{"htmlVersion.displayname", "htmlVersion" },
    		{"htmlVersionString.displayname", "htmlVersionString" },
    		{"specVersion.displayname", "specVersion" },
    		{"specVersionString.displayname", "specVersionString" },
    		{"issuer.displayname", "issuer" },
    		{"issuerName.displayname", "issuerName" },
    		{"issuDate.displayname", "issuDateString" },
    		{"registDate.displayname", "registDateString" },
    		{"severity.displayname", "severity" },
    		{"severityString.displayname", "severityString" },
    		{"priority.displayname", "priority" },
    		{"priorityString.displayname", "priorityString" },
    		{"status.displayname", "status" },
    		{"statusString.displayname", "statusString" },
    		{"statusWhitebord.displayname", "statusWhitebord" },
    		{"resolution.displayname", "resolution" },
    		{"resolutionString.displayname", "resolutionString" },
    		{"milestone.displayname", "milestone" },
    		{"milestoneString.displayname", "milestoneString" },
    		{"scid.displayname", "scid" },
    		{"keyword1.displayname", "keyword1" },
    		{"keyword2.displayname", "keyword2" },
    		{"keyword3.displayname", "keyword3" },
    		{"cpid1.displayname", "cpid1" },
    		{"cpid2.displayname", "cpid2" },
    		{"cpid3.displayname", "cpid3" },
    		{"cpid4.displayname", "cpid4" },
    		{"cpid5.displayname", "cpid5" },
    		{"reletedDoc.displayname", "reletedDoc" },
    		{"auther.displayname", "auther" },
    		{"autherName.displayname", "autherName" },
    		{"authDate.displayname", "authDateString" },
    		{"errorType.displayname", "errorType" },
    		{"errorTypeString.displayname", "errorTypeString" },
    		{"errorCause.displayname", "errorCause" },
    		{"errorCauseString.displayname", "errorCauseString" },
    		{"issuPno.displayname", "issuPno" },
    		{"issuPnoString.displayname", "issuPnoString" },
    		{"trainPno.displayname", "trainPno" },
    		{"trainPnoString.displayname", "trainPnoString" },
    		{"shouldFindPno.displayname", "shouldFindPno" },
    		{"shouldFindPnoString.displayname", "shouldFindPnoString" },
    		{"errorDelayReason.displayname", "errorDelayReason" },
    		{"errorDelayReasonString.displayname", "errorDelayReasonString" },
    		{"errorPoint.displayname", "errorPoint" },
    		{"releaseSchDate.displayname", "releaseSchDateString" },
    		{"analyst.displayname", "analyst" },
    		{"analystName.displayname", "analystName" },
    		{"analizeDate.displayname", "analizeDateString" },
    		{"updateSrc.displayname", "updateSrc" },
    		{"updateDoc.displayname", "updateDoc" },
    		{"updater.displayname", "updater" },
    		{"updaterName.displayname", "updaterName" },
    		{"bugUpdateDate.displayname", "bugUpdateDateString" },
    		{"releaseDate.displayname", "releaseDateString" },
    		{"comfirmer.displayname", "comfirmer" },
    		{"comfirmerName.displayname", "comfirmerName" },
    		{"comfirmDate.displayname", "comfirmDateString" },
    		{"updateUno.displayname", "updateUno" },
    		{"updateUnoName.displayname", "updateUnoName" },
    		{"updateDate.displayname", "updateDateString" },
    		{"subsystem.displayname", "subsystem" },
    		{"subsystemString.displayname", "subsystemString" },
    		
    };
	/**
	 * Log
	 */
	private Log log = LogFactory.getLog(this.getClass().getName());
//===========================================================================
// methods
//===========================================================================
	/**
	 * exevute
	 *
	 * @param mapping The ActionMapping used to select this instance
	 * @param actionForm The optional ActionForm bean for this request (if any)
	 * @param request The HTTP request we are processing
	 * @param response The HTTP response we are creating
	 *
	 * @exception Exception if business logic throws an exception
	 */
	public ActionForward doAction(ActionMapping mapping,
				 ActionForm form,
				 HttpServletRequest request,
				 HttpServletResponse response)
				throws Exception {
		/*  
		 */
		HttpSession session = getSession(request);	//sessio̎擾
		UserInfo user = (UserInfo)getAttribute(session,"UserInfo");	//OC[U̎擾
		ActionForward forward = null;
//		BugDownloadForm myForm = (BugDownloadForm)form;
		Collection bugNumbers = (Collection)session.getAttribute("bugNUmberList");
		
		//oOXg߂
		Collection bugs = BugFinder.findFullBug(bugNumbers);
		
		//Xg[̐
		String fileName = "buglist" + Converter.getDateString(new Date(), Converter.DATE) + ".csv";

		//wb_ZbgB
		response.reset();
		PrintWriter out =  response.getWriter();
//		response.setContentType("application/octet-stream");
        response.setContentType("application/Octet-Stream-Dummy");
		response.setHeader("Content-disposition", 
		    	"attachment; filename=\"" + fileName + "\"");

//		response.setContentType("application/unknown");
//		response.setHeader("Content-Disposition", "attachment; filename=" + fileName );
//		response.setHeader("Content-Disposition", "inline; filename=" + fileName);
		
		//wb_̏o
		writeHeader(out);
		
		Iterator ite = bugs.iterator();
		while(ite.hasNext()) {
			
			//f[^̏o
			writeData((FullBug)ite.next(), out);
		}
		
		out.flush();
		
//		forward = mapping.findForward("success");
		return null;
	}
	
	private void writeHeader(PrintWriter out) {
		
	    MessageString ms = new MessageString();
	    
		StringBuffer sb = new StringBuffer();
		
		for (int i = 0; i < CSV_ITEMS.length; i++) {
	        writeObject(ms.get(CSV_ITEMS[i][0]),sb);
		}
		
		
//		writeObject("̏ԍ", sb);
//		writeObject("̏ID", sb);
//		writeObject("^Cg", sb);
//		writeObject("S", sb);
//		writeObject("敪", sb);
//		writeObject("", sb);
//		writeObject("@\敪", sb);
//		writeObject("@\", sb);
//		writeObject("ʖ", sb);
//		writeObject("uEU敪", sb);
//		writeObject("uEU", sb);
//		writeObject("OS敪", sb);
//		writeObject("OS", sb);
//		writeObject("ID", sb);
//		writeObject("APo[W敪", sb);
//		writeObject("APo[W", sb);
//		writeObject("DBo[W敪,", sb);
//		writeObject("DBo[W", sb);
//		writeObject("HTMLo[W敪,", sb);
//		writeObject("HTMLo[W", sb);
//		writeObject("dlo[W敪", sb);
//		writeObject("dlo[W", sb);
//		writeObject("sҔԍ", sb);
//		writeObject("sҖ", sb);
//		writeObject("s", sb);
//		writeObject("o^", sb);
//		writeObject("̏x敪", sb);
//		writeObject("̏x", sb);
//		writeObject("Dx敪", sb);
//		writeObject("Dx", sb);
//		writeObject("", sb);
//		writeObject("Ԗ", sb);
//		writeObject("", sb);
//		writeObject("Ώ敪", sb);
//		writeObject("Ώ", sb);
//		writeObject("ڕW敪", sb);
//		writeObject("ڕW", sb);
//		writeObject("dlύXhc", sb);
//		writeObject("L[[hP", sb);
//		writeObject("L[[hQ", sb);
//		writeObject("L[[hR", sb);
//		writeObject("R|P", sb);
//		writeObject("R|Q", sb);
//		writeObject("R|R", sb);
//		writeObject("R|S", sb);
//		writeObject("R|T", sb);
//		writeObject("֘AODC", sb);
//		writeObject("FҔԍ", sb);
//		writeObject("F", sb);
//		writeObject("F", sb);
//		writeObject("G[e敪", sb);
//		writeObject("G[e", sb);
//		writeObject("G[敪", sb);
//		writeObject("G[", sb);
//		//-------------------------------------------
//		//Γc@2007/10/09 NO6 insert start
//		//CSVo͂ɃG[@\ӏȂߍڒǉ
//		writeObject("G[@\ӏ", sb);
//		//Γc@2007/10/09 NO6 insert end
//		//-------------------------------------------
//		writeObject("H敪", sb);
//		writeObject("H", sb);
//		writeObject("H敪", sb);
//		writeObject("H", sb);
//		writeObject("EoׂH敪", sb);
//		writeObject("EoׂH", sb);
//		writeObject("EoxR敪", sb);
//		writeObject("EoxR", sb);
//		writeObject("񋟗\", sb);
//		writeObject("͎Ҕԍ", sb);
//		writeObject("͎", sb);
//		writeObject("͓", sb);
//		writeObject("C\[X", sb);
//		writeObject("CDOC", sb);
//		writeObject("CҔԍ", sb);
//		writeObject("C", sb);
//		writeObject("C", sb);
//		writeObject("񋟓", sb);
//		writeObject("mFҔԍ", sb);
//		writeObject("mF", sb);
//		writeObject("mF", sb);
//		writeObject("ŏIXVҔԍ", sb);
//		writeObject("ŏIXV", sb);
//		writeObject("ŏIXV", sb);

		writeObject("̏e", sb);
		writeObject("je", sb);
		writeObject("͓e", sb);
		writeObject("Ce", sb);
		writeObject("mFe", sb);
		
		out.println(sb.toString());
	}
	private void writeData(FullBug bug, PrintWriter out) {
		
		StringBuffer sb = new StringBuffer();

		for (int i = 0; i < CSV_ITEMS.length; i++) {
		    try {
		        writeObject(BeanUtils.getProperty(bug,CSV_ITEMS[i][1]),sb);
		    }catch (Exception e) {
		        throw new BLRuntimeException(e.getMessage());
		    }
		}
		
//		writeObject(bug.getBno(), sb);
//		writeObject(bug.getBid(), sb);
//		writeObject(bug.getTitle(), sb);
//		writeObject(bug.getDispatchName(), sb);
//		writeObject(bug.getLocation(), sb);
//		writeObject(bug.getLocationString(), sb);
//		writeObject(bug.getFunctionName(), sb);
//		writeObject(bug.getFunctionNameString(), sb);
//		writeObject(bug.getScreen(), sb);
//		writeObject(bug.getBrowser(), sb);
//		writeObject(bug.getBrowserString(), sb);
//		writeObject(bug.getOs(), sb);
//		writeObject(bug.getOsString(), sb);
//		writeObject(bug.getTid(), sb);
//		writeObject(bug.getAppVersion(), sb);
//		writeObject(bug.getAppVersionString(), sb);
//		writeObject(bug.getDbVersion(), sb);
//		writeObject(bug.getDbVersionString(), sb);
//		writeObject(bug.getHtmlVersion(), sb);
//		writeObject(bug.getHtmlVersionString(), sb);
//		writeObject(bug.getSpecVersion(), sb);
//		writeObject(bug.getSpecVersionString(), sb);
//		writeObject(bug.getIssuer(), sb);
//		writeObject(bug.getIssuerName(), sb);
//		writeObject(bug.getIssuDate(), sb);
//		writeObject(bug.getRegistDate(), sb);
//		writeObject(bug.getSeverity(), sb);
//		writeObject(bug.getSeverityString(), sb);
//		writeObject(bug.getPriority(), sb);
//		writeObject(bug.getPriorityString(), sb);
//		writeObject(bug.getStatus(), sb);
//		writeObject(bug.getStatusString(), sb);
//		writeObject(bug.getStatusWhitebord(), sb);
//		writeObject(bug.getResolution(), sb);
//		writeObject(bug.getResolutionString(), sb);
//		writeObject(bug.getMilestone(), sb);
//		writeObject(bug.getMilestoneString(), sb);
//		writeObject(bug.getScid(), sb);
//		writeObject(bug.getKeyword1(), sb);
//		writeObject(bug.getKeyword2(), sb);
//		writeObject(bug.getKeyword3(), sb);
//		writeObject(bug.getCpid1(), sb);
//		writeObject(bug.getCpid2(), sb);
//		writeObject(bug.getCpid3(), sb);
//		writeObject(bug.getCpid4(), sb);
//		writeObject(bug.getCpid5(), sb);
//		writeObject(bug.getReletedDoc(), sb);
//		writeObject(bug.getAuther(), sb);
//		writeObject(bug.getAutherName(), sb);
//		writeObject(bug.getAuthDate(), sb);
//		writeObject(bug.getErrorType(), sb);
//		writeObject(bug.getErrorTypeString(), sb);
//		writeObject(bug.getErrorCause(), sb);
//		writeObject(bug.getErrorCauseString(), sb);
//		writeObject(bug.getIssuPno(), sb);
//		writeObject(bug.getIssuPnoString(), sb);
//		writeObject(bug.getTrainPno(), sb);
//		writeObject(bug.getTrainPnoString(), sb);
//		writeObject(bug.getShouldFindPno(), sb);
//		writeObject(bug.getShouldFindPnoString(), sb);
//		writeObject(bug.getErrorDelayReason(), sb);
//		writeObject(bug.getErrorDelayReasonString(), sb);
//		writeObject(bug.getErrorPoint(), sb);
//		writeObject(bug.getReleaseSchDate(), sb);
//		writeObject(bug.getAnalyst(), sb);
//		writeObject(bug.getAnalystName(), sb);
//		writeObject(bug.getAnalizeDate(), sb);
//		writeObject(bug.getUpdateSrc(), sb);
//		writeObject(bug.getUpdateDoc(), sb);
//		writeObject(bug.getUpdater(), sb);
//		writeObject(bug.getUpdaterName(), sb);
//		writeObject(bug.getBugUpdateDate(), sb);
//		writeObject(bug.getReleaseDate(), sb);
//		writeObject(bug.getComfirmer(), sb);
//		writeObject(bug.getComfirmerName(), sb);
//		writeObject(bug.getComfirmDate(), sb);
//		writeObject(bug.getUpdateUno(), sb);
//		writeObject(bug.getUpdateUnoName(), sb);
//		writeObject(bug.getUpdateDate(), sb);
		
		
		writeAddText(bug.getTroubleAddText(), sb);
		writeAddText(bug.getPrincipalAddText(), sb);
		writeAddText(bug.getCauseAddText(), sb);
		writeAddText(bug.getUpdateAddText(), sb);
		writeAddText(bug.getConfirmAddText(), sb);
		
		out.println(sb.toString());
	}
	private void writeObject(Object o ,StringBuffer sb) {
		if (sb.length() > 0) {
			sb.append(",");
		}
		if (o != null) {
			if (o instanceof java.lang.String) {
				String s = (String)o;
				
				sb.append("\"");
				sb.append(convertString(s));
				sb.append("\"");
			} else if (o instanceof java.util.Date) {
				
				sb.append(Converter.getDateString((Date)o));
				
			} else {
				sb.append(o);
			}
		}
	}
	private void writeObject(int i , StringBuffer sb) {
		if (sb.length() > 0) {
			sb.append(",");
		}
		sb.append(i);
	}
	private void writeObject(byte b , StringBuffer sb) {
		if (sb.length() > 0) {
			sb.append(",");
		}
		sb.append(b);
	}
	private void writeObject(long l , StringBuffer sb) {
		if (sb.length() > 0) {
			sb.append(",");
		}
		sb.append(l);
	}
	private void writeAddText(Collection col, StringBuffer sb) {
		if (sb.length() > 0) {
			sb.append(",");
		}
		
		Iterator ite = col.iterator();
		boolean flag = false;
		while (ite.hasNext()) {
			if (flag) {
				sb.append("\n---\n");
			} else {
				sb.append("\"");
				flag = true;
			}
			
			AddText text = (AddText)ite.next();
			StringBuffer buf = new StringBuffer(text.getContent());
			int offset = 0;
			while(offset < buf.length()) {
				char c = buf.charAt(offset);
				
				//"_uR[e[VH
				//̏ꍇAO"_vR[e[Vň͂
				if (c == '\"') {
					buf.insert(offset,'\"');
					offset += 2;
//					buf.insert(offset,'\"');
//					offset++;
				//sR[h 0x0D0Aexelł̉sR[h0x0AɕϊB
				//ł͒P0x0d(\r)폜邱ƂŎ
				} else if (c == '\r') {
					buf.delete(offset,offset+1);
					offset++;
				//ȊO͂̂܂
				} else {
					offset++;
				}
			
			}
			sb.append(convertString(buf.toString()));
		}
		if (flag) {
			sb.append("\"");
		}
		
	}
	
	private String convertString(String s) {
		String ss = null;
		
		try {
			ss = new String(s.getBytes(), "ISO_8859-1");
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		return ss;
	}
}
